Jump to content
guitarpirate

How to weld/merge vertices or edges?

Recommended Posts

guitarpirate

Hello,

 

I have a problem with artifacts in the 3D solid. AutoCAD didn't let me create perfect lofts because it has a restriction on every loft polyline having its vertices on the same plane. Thus I couldn't position them perfectly and they cut into the solid in places where I didn't want them to, creating extra edges and vertices. Since there was no way to fix that while lofting, I now have to try and fix it after the boolean operation.

 

Here are the pics:

 

Area to be welded:

weld_zoomin.jpg

 

Overview. Above is close-up of one of the circled edges in screenshot below.

weld_over.jpg

 

So far I hear that I have to write my own script in C# to do this? I am OK with doing it, but does the object model even allow welding vertices? If not, i will be wasting time learning it.

Share this post


Link to post
Share on other sites
ReMark

Perhaps using a different method to create the part would eliminate the problem and thus save you from having to write any code at all?

Share this post


Link to post
Share on other sites
JD Mather
... Since there was no way to fix that while lofting...

I am sure there is. That looks like a pretty simple part to me.

Attach the dwg file here.

 

So far I hear that I have to write my own script in C# to do this? I am OK with doing it, ...

I would find a new source of information, that would not be OK with me.

Attach your dwg file here.

Share this post


Link to post
Share on other sites
guitarpirate

Thanks for quick reply!

 

In that case I hope you can give me tips on how to re-create this from scratch with clean geometry (this one is probably beyound repair, solid history doesn't work). I actually spent over 2 weeks on making it and even payed $100 to an expert to meet in Starbucks and have him show me how to do it, but to no avail.

 

Attaching in ACAD 2014 format (DWG in RAR). I apologize for not using ZIP as you probably don't have WinRAR installed, but size was over limit with zip. I can re-attach as 7zip if that's more convenient.

ArtifactHelp.rar

Share this post


Link to post
Share on other sites
JD Mather

I only have Windows for extracting files on my home computer.

Maybe sometime next week (if someone else doesn't jump in here) I can get the file from a work computer.

 

$100? Users here on this forum routinely solve far more complex problems for free.

Share this post


Link to post
Share on other sites
Cad64
I only have Windows for extracting files on my home computer.

 

I use JZip. It's free and can unzip many file formats. If you're interested: http://www.jzip.com/

Share this post


Link to post
Share on other sites
guitarpirate

I started working on another part and I have the same problem, so maybe it's a good time to break that down. Let's say I have a ridge and I want to taper it somewhat on Z axis, from beginning of that ridge "section" to the end. The "max taper" would be current ridge height and "min taper" would be a specific measure on Z axis which is less than ridge height.

 

I try to handle this by first drawing a line up on Z axis from the bottom of ridge's tip to top (midpoint to midpoint), following the surface. I make this line of specific height to measure the "min" taper on the end of the ridge. Then I draw a line in the flat area of the bottom and move it by midpoint to the end of the measuring line. This creates the first cut line on the face of ridge's tip. Then I draw another line exactly outlining the start of point of the ridge at the very top, where "max" taper is equal to ridge's current height. Then I draw two lines on each side. I join all the lines except temp measuring line into 3d poly and try to extrude, which usually doesn't work (creates 4 surfaces instead of a solid, which cannot be used for the boolean I need). To troubleshoot, I set UCS to follow the cut surface, switch to top view of new UCS and use FLATTEN command to flatten all polyline verts to the same plane. This moves one of the verts and AC doesn't let me move it back. Now the 3d polyline can be extruded and subtracted from the ridge, but creates extra geometry.

 

I attached a step by step illustration.

 

My guess is this is extra labor-intensive or plain wrong method to do this, so any tips are appreciated!

 

(TYPO: in step #3, description should read "midpoint of horizontal line to endpoint of vertical line")

 

my_process.jpg

 

subtract.jpg

Share this post


Link to post
Share on other sites
guitarpirate

Well I realized something I haven't used yet... Solid features (verts, edges and faces) are editable by Ctrl+Clicking on a feature, so it's possible to taper a ridge by dragging on top edge of the tip, and move down by X units. That makes stuff much less complicated. In certain cases like making a little pyramid on top of a cross, I bet I could use Imprint to create edges on the top plane and then simply drag the pyramid top vert up to create a pyramid shape.

Share this post


Link to post
Share on other sites
ReMark

Slice to a Taper 1.JPG

Is this kind of what you are looking to do?

Share this post


Link to post
Share on other sites
ReMark

Slice to a Taper 2.jpg

From right to left.

 

-Basic shape

-Extruded shape with lines (red)

-Mesh (green) created with Edgesurf command

-Mesh converted to surface (cyan)

-2Dwireframe of finished shape

 

I'm sure that JDM can knock off a step or two.

Share this post


Link to post
Share on other sites
ReMark

Artifact_1.jpg

My version of the piece you are having a problem with.

It is only roughly based on your geometry and shown here for demonstration purposes.

Basically I created the base profile, extruded it, then sliced it with an inclined surface that was revolved around the part's center point.

I think I stole the technique from a tutorial JDM did. If so the credit really belongs to him.

Share this post


Link to post
Share on other sites
guitarpirate

[EDIT - responding to your first post]

So the edgesurf worked and the Mesh conversion worked, but I don't understand what you did to make the bottom disappear in the last picture. Extrude doesn't work on that surface, it extrudes every single facet separately using its edges.

 

Thanks for the help, I appreciate you spending the time!

 

Regarding the yellow cross piece, I want a 4-sided pyramid at the top. Revolving a shape (correct me if I'm wrong) will create a smooth dome so the pyramid ribs won't be visible.

Share this post


Link to post
Share on other sites
JD Mather
I use JZip. It's free and can unzip many file formats. If you're interested: http://www.jzip.com/

 

Thanks, but no thanks.

I keep my personal computer super clean and never experience the problems others report in desperation.

I have a test machine at work that I use for stuff like this.

Unfortunately I don't get into the office much between May and August.

Share this post


Link to post
Share on other sites
JD Mather
I want a 4-sided pyramid at the top.

 

Loft a square (or other desired base shape) to a point. (actually the other way around, the POint to the polygon)

 

I exaggerated the height for illustrative purposes.

 

Loft to Point.jpg

 

I don't see any special geometry in your images (but then, I haven't looked at the dwg file).

Only planar and cylindrical faces, as basic as it gets.

Share this post


Link to post
Share on other sites
SEANT

I can’t say I recognize the object but find the chaotic, industrialized form rather intriguing. The cross on that object does not have perfect symmetry – pretty close but not exact. Is that intentional? I have to assume that it is based on the overall shape, as well as the crosses on the other object in that file.

Are there parameters that you would like to maintain? For instance, do all the faces need to be planar? The solid in post #7 could be sliced with a surface that passed through all four points, but the resultant face would no longer be planar.

Share this post


Link to post
Share on other sites
SEANT

Incidentally, the AutoCAD API’s do not provide a direct way to modify an Autodesk.AutoCAD.DatabaseServices.Solid3d’s vertex. An automated effect may be possible, but it would use similar techniques as required by AutoCAD’s drawing editor.

Share this post


Link to post
Share on other sites
ReMark

So the edgesurf worked and the Mesh conversion worked, but I don't understand what you did to make the bottom disappear in the last picture.

To achieve the end result I removed the bottom of the object using the SLICE command with the SURFACE option. The SURFACE option allows the user to specify which side to retain (or both). The opposite side is automatically deleted.

 

Extrude doesn't work on that surface, it extrudes every single facet separately using its edges.

EXTRUDE is not the solution to every problem one faces when creating a 3D model. Open yourself up to other solid editing tools.

 

Thanks for the help, I appreciate you spending the time!

You're welcomed. It did not involve much time at all.

 

Regarding the yellow cross piece, I want a 4-sided pyramid at the top. Revolving a shape (correct me if I'm wrong) will create a smooth dome so the pyramid ribs won't be visible.

I am not at my CAD computer right now but just because you don't see any pyramid-like lines doesn't mean the piece I created is incorrect. Besides which, having that pyramid does not appear to have any worthwhile design function that I can see.

Share this post


Link to post
Share on other sites
guitarpirate

The slice/surf method totally works, great addition to my toolbox - thanks a lot ReMark! After staring at this geometry and feeling helpless for days, that gave me a nerdrenaline rush :) I don't know yet how well that will work with the cross shapes, I might have to slice off each branch of the cross before applying and then boolean them again. Worked perfectly with the ridge though, and I ended up going with a stright cut to maintain the surfaces perpendicular to each other on X/Y (SEANT: yes I did prefer them to be straight facing, although after experimenting with slicing I realized what I wanted originally could not be done with straight-facing planes).

 

JDM: your method for creating pyramid worked fine on dummy geometry, I don't think I will have a problem there. I still have an earlier iteration of the bent part in post #1, so I will try to restart from that iteration and find a way not to introduce the artifacts. Thanks for your help, if after doing this I am still stuck I will upload the .zip to my website FTP and post a link.

 

SEANT: I didn't realize the cross shape on the bent piece was not symmetrical, as I created one branch of the cross, copied 3 more times and rotated each 90 degree multiplies, then joined together. Perhaps lack of symmetry contributed to bad geometry here. I will re-create this part.

Share this post


Link to post
Share on other sites
ReMark

Or create one branch then do a polar array. Just make sure your UCS in located/oriented properly.

Share this post


Link to post
Share on other sites

Join the conversation

You can post now and register later. If you have an account, sign in now to post with your account.
Note: Your post will require moderator approval before it will be visible.

Guest
Reply to this topic...

×   Pasted as rich text.   Paste as plain text instead

  Only 75 emoji are allowed.

×   Your link has been automatically embedded.   Display as a link instead

×   Your previous content has been restored.   Clear editor

×   You cannot paste images directly. Upload or insert images from URL.


×
×
  • Create New...